package example

import com.intuit.karate.core.MockServer
import io.gatling.core.Predef._
import io.gatling.http.Predef._

import scala.concurrent.duration._
import scala.util.Properties

class GatlingSimulation extends Simulation {

  def getServerUrl: String = {
    if (Properties.propOrEmpty("karate.env") == "mock") {
      val server = MockServer.feature("classpath:example/mockServer.feature").build()
      "http://localhost:" + server.getPort
    } else {
      "http://localhost:8000"
    }
  }
  val serverUrl = getServerUrl
  val protocol = http.baseUrl(serverUrl)

  val example = scenario("example")
    .exec(
      http("GET /test")
        .get("/test")
        // By default, it checks status.find.in(200,201,202,203,204,205,206,207,208,209,304)
        // so this has been added so that it doesn't consider the expected 404 from the non-Karate mock server as KO
        .check(status.lt(500))
    )

  setUp(
    example.inject(rampUsers(100) during (10 seconds)).protocols(protocol)
  )
}
