package example

import com.intuit.karate.core.MockServer
import com.intuit.karate.gatling.PreDef._
import io.gatling.core.Predef._

import scala.concurrent.duration._
import scala.util.Properties

class KarateSimulation extends Simulation {

  def getServerUrl: String = {
    if (Properties.propOrEmpty("karate.env") == "mock") {
      val server = MockServer.feature("classpath:example/mockServer.feature").build()
      "http://localhost:" + server.getPort
    } else {
      "http://localhost:8000"
    }
  }
  val serverUrl = getServerUrl
  System.setProperty("server.url", serverUrl)

  val example = scenario("example")
    .exec(karateFeature("classpath:example/example.feature"))

  setUp(
    example.inject(rampUsers(100) during (10 seconds))
  )
}
